<template>
    <div class="q-gutter-y-lg full-width">

        <q-select emit-value
                  map-options
                  label-slot
                  filled
                  :options="subs"
                  option-label="name"
                  option-value="id"
                  @input="Input('subId',$event)"
                  :value="value.subId"
        >
            <template v-slot:label>
                <LabelSlot icon="icofont-building-alt" label="SubContractor"
                           tooltip="Choose a subcontractor first"/>
            </template>
        </q-select>
        <q-select
            v-if="value.subId !== '' && workers.length > 0"
            emit-value
            map-options
            label-slot
            filled
            :options="workers"
            option-label="name"
            option-value="id"
            @input="Input('workerId',$event)"
            :value="value.workerId"
        >
            <template v-slot:label>
                <LabelSlot icon="icofont-worker" label="Worker"
                           tooltip="The worker for analytics"/>
            </template>
        </q-select>
        <q-select
            v-if="Ready"
            :options="WorkerChartType"
            emit-value
            map-options
            label-slot
            filled
            @input="Input('type',$event)"
            :value="value.type">
            <template v-slot:label>
                <LabelSlot icon="icofont-dashboard-web" label="Chart Type"
                           tooltip="The chart to type to visualize the analytics"/>
            </template>

            <template v-slot:option="scope">
                <q-item v-bind="scope.itemProps" v-on="scope.itemEvents">
                    <q-item-section avatar>
                        <q-icon :name="scope.opt.icon"/>
                    </q-item-section>
                    <q-item-section>
                        <q-item-label>
                            {{ scope.opt.label }}
                        </q-item-label>
                    </q-item-section>
                </q-item>
            </template>
        </q-select>

        <q-toggle v-if='Ready' :value="value.merge"
                  @input="Input('merge',$event)" label="Merge Zones" icon="call_merge"/>
        <q-toggle v-if="Ready && value.type === 'line' && value.merge" label="Specify floor"
                  :value="value.specifyFloor"
                  @input="Input('specifyFloor',$event)"
        />
        <q-select v-if="Ready && value.type === 'line' && value.merge && value.specifyFloor"
                  emit-value
                  map-options
                  label-slot
                  filled
                  :options="floors"
                  option-label="name"
                  option-value="id"
                  :value="value.floorId"
                  @input="Input('floorId',$event)"
        >
            <template v-slot:label>
                <LabelSlot icon="layer" label="Floor"
                           tooltip="The floor to scope to"/>
            </template>
        </q-select>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import FormCore from "components/FormCore.vue";
import LabelSlot from "components/LabelSlot.vue";
import {WorkerGraphType} from "src/classLibrary/Charting/WorkerChart";
import {FloorPrincipalResponse} from "src/classLibrary/APIModels/core/floorPrincipalResponse";
import {SubContractorPrincipalResponse} from "src/classLibrary/APIModels/core/subContractorPrincipalResponse";
import {WorkerPrincipalResponse} from "src/classLibrary/APIModels/core/workerPrincipalResponse";
import {DeepClone} from "src/classLibrary/Utility";

export interface WorkerChartOptionsWidgetInterface {
    subId: string,
    workerId: string,
    merge: boolean,
    type: string,
    floorId: string,
    specifyFloor: boolean,
}

@Component({
    components: {LabelSlot, FormCore}
})
export default class FloorChartOptions extends Vue {
    @Prop() days!: string[];
    @Prop() value!: WorkerChartOptionsWidgetInterface;
    floors: FloorPrincipalResponse[] = [];
    subs: SubContractorPrincipalResponse[] = [];
    workers: WorkerPrincipalResponse[] = [];


    Input(key: string, value: string) {
        const v = DeepClone(this.value) as any;

        v[key] = value;
        if (key === 'subId') {
            v['workerId'] = ''
            Vue.nextTick(() => this.loadWorkers())
        }
        this.$emit('input', v);
    }


    get Ready() {
        return this.value.subId !== '' && this.value.workerId !== ''
    }

    async created() {
        await this.loadSubs();
        await this.loadFloors();
    }


    async loadWorkers() {
        if (this.value.subId === '') return;
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<WorkerPrincipalResponse[]>(
            `Worker?projectId=${this.PersistentStore.StoreValue.project}&SubContractor=${this.value.subId}`, null, t);

        r.match({
            err: (e) => p.$emit('error', e),
            ok: (o) => {
                p.workers = o;
            }
        })

    }

    async loadSubs() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<SubContractorPrincipalResponse[]>(`SubContractor?projectId=${this.PersistentStore.StoreValue.project}`, null, t);

        r.match({
            err: (e) => p.$emit('error', e),
            ok: (o) => {
                p.subs = o;
            }
        })

    }

    async loadFloors() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<FloorPrincipalResponse[]>(`Floor?projectId=${this.PersistentStore.StoreValue.project}`, null, t);
        r.match({
            err: (e) => {
                p.$emit('error', e);
            },
            ok: (o) => {
                p.floors = o;
            }
        })

    }

    get WorkerChartType() {
        return WorkerGraphType;
    }


}
</script>

<style lang='scss' scoped>

</style>
